
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma pack(1)

typedef unsigned short word;
typedef unsigned int   uint;
typedef unsigned char  byte;

uint flen( FILE* f ) {
  fseek( f, 0, SEEK_END );
  uint len = ftell(f);
  fseek( f, 0, SEEK_SET );
  return len;
}

enum {
  winlog=12,
  winsize=(1<<winlog),
  winmask=(1<<winlog)-1
};
byte win[winsize];

int main( int argc, char** argv ) {

  if( argc<3 ) return 2;

  uint c,d,r,l,i,j,flag,pos;

  FILE* f = fopen( argv[1], "rb" ); if( f==0 ) return 2;
  FILE* g = fopen( argv[2], "wb" ); if( g==0 ) return 2;

  for( i=0; i<winsize; i++ ) win[i]=0;

  for( pos=0xFEE;; ) {
    c = getc(f); if( c==-1 ) break;
    flag = c;

    for( i=0; i<8; i++ ) {  

      c = getc(f); 

      if( (flag>>i)&1 ) {
        // literal
        win[ (pos++)&winmask ] = c; putc( c, g );

      } else {
        // match

        d = getc(f);

        l = (d & 15) + 3;
        d = c + (d>>4)*256;

        for( j=0; j<l; j++ ) {
          c = win[ (d+j)&winmask ];
          win[ (pos++)&winmask ] = c; putc( c, g );
        }

      }

    }
  }


}
